#
# this file contains all method to drawing charts
#

def network_status_pie(node, size=400)

  g=Gruff::Pie.new(size)
	begin
		#this method depends on gruff version
  		g.legend_at_bottom=true
	rescue
	end

  g.theme = {
    :marker_color => 'black',
    :font_color => 'black',
    :background_colors => 'transparent'
  }

  sev_stat=Array.new($status_value.size,0)

  node.get_node().each_value do |n| 
		sev_stat[$status_value.index(n.status)]+=1
  end

  status_index=0
  $status.each do |stat|

	 sev_percent=0
	 if node.nb_node>0
		sev_percent=(sev_stat[status_index]*100)/node.nb_node.to_f()
	 end
	 if sev_stat[status_index] > 0
		  g.data(sev_stat[status_index].to_s()+" "+stat.capitalize(), [sev_percent.round()], hexa_to_rgb_color_str($status_color[status_index]))
	 end
	 status_index+=1
end

#g.hide_legend=true
#g.data("Critical", [1])
#g.data("Major", [1])
#g.data("Warning", [1])
#g.data("Minor", [1])
#g.data("Normal", [1])
#g.data("Unmanaged", [1])
#g.data("Unkown", [1])

#g.write('my_test.png')
return g.to_blob { self.format='PNG' }

end
