class CustomPluginWindow

	#populate listview with saved values
	def populate_ls()
   	$custom_monitor.each do |name|
		  iter = @custom_ref_ls.append
		  iter[0] = name
		  descr = "No description available"
		  begin
		    descr = Object.const_get(name).name()
		  rescue		    
		  end
		  iter[1] = descr		  
		end
	end

	def initialize()
		window=Gtk::Window.new
	   	window.set_title("Custom Plugin Configuration")
   		window.set_size_request(500, 300)

	        window.signal_connect("key_press_event") {|w,e|
        	if e.keyval == Gdk::Keyval::GDK_Escape
			  window.destroy
	        end
   		}

		frame = Gtk::Frame::new
		frame.border_width=5
		frame.show
		vbox_root=Gtk::VBox::new
		vbox_root.show
		window.add vbox_root
		vbox_root.add frame

		vbox = Gtk::VBox.new(false,0)
		vbox.show
		frame.add vbox

                @custom_ref_ls = Gtk::ListStore.new(String, String)
                @custom_ref_view = Gtk::TreeView.new(@custom_ref_ls)
		@custom_ref_view.show
 		column1 = Gtk::TreeViewColumn.new("Name",
					Gtk::CellRendererText.new, {:text => 0})
  		column1.set_sort_column_id(0)
  		column2 = Gtk::TreeViewColumn.new("Description",
					Gtk::CellRendererText.new, {:text => 1})
  		column2.set_sort_column_id(1)

  		@custom_ref_view.append_column(column1)
  		@custom_ref_view.append_column(column2)
  		
		scroll = Gtk::ScrolledWindow.new(nil, nil)
		scroll.border_width=2
		scroll.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_AUTOMATIC)  
		scroll.add @custom_ref_view
		scroll.show
		
		populate_ls()
		vbox.add(scroll)

		bbox = Gtk::HBox::new(FALSE, 10)
		bbox.border_width=10
		bbox.show

		ok_button = Gtk::Button.new(Gtk::Stock::OK)
		ok_button.show
		ok_button.signal_connect("clicked") {
			window.destroy
		}

		cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
		cancel_button.show
		cancel_button.signal_connect("clicked") {
                   window.destroy
		}
		ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
		bbox.pack_start(ok_button, TRUE, TRUE, 0)
		cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
		bbox.pack_start(cancel_button, TRUE, TRUE, 0)

		separator = Gtk::HSeparator::new()
		separator.show
		vbox_root.pack_start(separator, FALSE, TRUE, 0)
		vbox_root.pack_start(bbox, FALSE, TRUE, 0)

		window.show
   end

end
