class LinkView

   def initialize (map, lnk, status)
	@visible=true
	@link=lnk
	@group = Goo::CanvasGroup.new($network[map].map_view,{:x => 0.0,:y => 0.0, :can_focus => true})
	@group.lower(nil)
	@color = $status_color[$status_value.index(status)]
	display()
   end

	def display()
		self.show()
	   @lign=Goo::CanvasPolyline.new(@group, false,
                       [[@link.node1.x+@link.node1.node_view.get_node_size()/2,@link.node1.y+@link.node1.node_view.get_node_size()/2],
			[@link.node2.x+@link.node2.node_view.get_node_size()/2,@link.node2.y+@link.node2.node_view.get_node_size()/2]],
                         :stroke_color_rgba => @color,
                         :line_width => 2.0)
	end

	def show()
		@visible=true
		@group.visibility = Goo::CanvasItem::VISIBLE
	end

	def hide()
		@visible=false
		@group.visibility = Goo::CanvasItem::HIDDEN
	end

	def remove_link()
		@group.remove_child(@lign)
	end
	
	def color(cl)
	  @color = cl
	  Gtk.thread_protect do
	    @lign.stroke_color_rgba = @color
	  end
	end
	
	def update_status(st)
          color($status_color[$status_value.index(st)])	   
	end
	
end #class
