#provide contact details as: firstname lastname email phone mobile im pager location note

  frame_contact = Gtk::Frame::new
  frame_contact.border_width=10
  frame_contact.show

  vbox = Gtk::VBox::new
  vbox.show
  frame_contact.add vbox

  contact_ls = Gtk::ListStore.new(String, String, String)
  @contact_view = Gtk::TreeView.new(contact_ls)

  def cell_edited(cell, path_string, new_text, col)
	iter = @contact_view.model.get_iter(path_string)

  end

  tr0=Gtk::CellRendererText.new
  #prenom
  column1 = Gtk::TreeViewColumn.new("First Name", tr0, {:text => 0})
  column1.set_sort_column_id(0)
  
  tr1=Gtk::CellRendererText.new
  #nom
  column2 = Gtk::TreeViewColumn.new("Last Name", tr1, {:text => 1})
  column2.set_sort_column_id(1)

  @contact_view.append_column(column1)
  @contact_view.append_column(column2)
  @contact_view.show

  def add_contact_entry()
	add_contact_entry_details(true)
	if @cb_mail
		@cb_mail.set_sensitive(@button_mail.active?)
	    	@cb_im.set_sensitive(@button_im.active?)
		@cb_sms.set_sensitive(@entry_sms_device.text != "")
		@entry_mail_button.set_sensitive(@cb_mail.active?)
		@entry_im_button.set_sensitive(@cb_im.active?)
		@entry_sms_button.set_sensitive(@cb_sms.active?)
	end
  end
  
  def edit_contact_entry(ref)
	add_contact_entry_details(false, ref)
  end
  
  def add_contact_entry_details(add_boolean, ref=nil)
	window=Gtk::Window.new
	window.set_modal(true)
	lbl="Edit Contact Entry"
	if add_boolean
		lbl="Add Contact Entry"
	end
		
   	window.set_title(lbl)
   	window.set_size_request(460, 380)

	window.signal_connect("key_press_event") {|w,e|
        	if e.keyval == Gdk::Keyval::GDK_Escape
			window.destroy
	        end
   	}

	frame = Gtk::Frame::new
	frame.border_width=10
	frame.show
	vbox_root=Gtk::VBox::new
	vbox_root.show
	window.add vbox_root
	vbox_root.add frame

	vbox = Gtk::VBox.new
	vbox.show
	frame.add vbox

	table = Gtk::Table.new(11,2,false)
	table.show

	label_fname = Gtk::Label.new "First Name"
	label_fname.show
	if add_boolean
		entry_fname = Gtk::Entry.new			
	else
		entry_fname = Gtk::Entry.new	
		entry_fname.set_editable false
		entry_fname.set_text(ref[0])
	end
	entry_fname.show
	table.attach(label_fname,0,1,0,1)
	table.attach(entry_fname,1,2,0,1)

	label_lname = Gtk::Label.new "Last Name"
	label_lname.show
	if add_boolean
		entry_lname = Gtk::Entry.new			
	else
		entry_lname = Gtk::Entry.new	
		entry_lname.set_editable false
		entry_lname.set_text(ref[1])
	end
	entry_lname.show
	table.attach(label_lname,0,1,1,2)
	table.attach(entry_lname,1,2,1,2)

	label_email = Gtk::Label.new "Email"
	label_email.show
	if add_boolean
		entry_email = Gtk::Entry.new			
	else
		entry_email = Gtk::Entry.new	
		entry_email.set_text($contact["#{ref[0]}|#{ref[1]}"].email)
	end
	entry_email.show
	table.attach(label_email,0,1,2,3)
	table.attach(entry_email,1,2,2,3)
	
	label_phone = Gtk::Label.new "Phone"
	label_phone.show
	if add_boolean
		entry_phone = Gtk::Entry.new			
	else
		entry_phone = Gtk::Entry.new	
		entry_phone.set_text($contact["#{ref[0]}|#{ref[1]}"].phone)
	end
	entry_phone.show
	table.attach(label_phone,0,1,3,4)
	table.attach(entry_phone,1,2,3,4)

	label_mobile = Gtk::Label.new "Mobile"
	label_mobile.show
	if add_boolean
		entry_mobile = Gtk::Entry.new			
	else
		entry_mobile = Gtk::Entry.new	
		entry_mobile.set_text($contact["#{ref[0]}|#{ref[1]}"].mobile)
	end
	entry_mobile.show
	table.attach(label_mobile,0,1,4,5)
	table.attach(entry_mobile,1,2,4,5)

	label_pager = Gtk::Label.new "Pager"
	label_pager.show
	if add_boolean
		entry_pager = Gtk::Entry.new			
	else
		entry_pager = Gtk::Entry.new	
		entry_pager.set_text($contact["#{ref[0]}|#{ref[1]}"].pager)
	end
	entry_pager.show
	table.attach(label_pager,0,1,5,6)
	table.attach(entry_pager,1,2,5,6)
		
	label_im = Gtk::Label.new "IM"
	label_im.show 
	if add_boolean
		entry_im = Gtk::Entry.new			
	else
		entry_im = Gtk::Entry.new	
		entry_im.set_text($contact["#{ref[0]}|#{ref[1]}"].im)
	end
	entry_im.show
	table.attach(label_im,0,1,6,7)
	table.attach(entry_im,1,2,6,7)

	label_title = Gtk::Label.new "Title"
	label_title.show 
	if add_boolean
		entry_title = Gtk::Entry.new			
	else
		entry_title = Gtk::Entry.new	
		entry_title.set_text($contact["#{ref[0]}|#{ref[1]}"].title)
	end
	entry_title.show
	table.attach(label_title,0,1,7,8)
	table.attach(entry_title,1,2,7,8)
	
	label_organization = Gtk::Label.new "Organization"
	label_organization.show 
	if add_boolean
		entry_organization = Gtk::Entry.new			
	else
		entry_organization = Gtk::Entry.new	
		entry_organization.set_text($contact["#{ref[0]}|#{ref[1]}"].organization)
	end
	entry_organization.show
	table.attach(label_organization,0,1,8,9)
	table.attach(entry_organization,1,2,8,9)	

	label_location = Gtk::Label.new "Location"
	label_location.show
	if add_boolean
		entry_location = Gtk::Entry.new			
	else
		entry_location = Gtk::Entry.new	
		entry_location.set_text($contact["#{ref[0]}|#{ref[1]}"].location)
	end
	entry_location.show
	table.attach(label_location,0,1,9,10)
	table.attach(entry_location,1,2,9,10)

	label_note = Gtk::Label.new "Note"
	label_note.show
	if add_boolean
		entry_note = Gtk::Entry.new			
	else
		entry_note = Gtk::Entry.new	
		entry_note.set_text($contact["#{ref[0]}|#{ref[1]}"].note)
	end
	entry_note.show
	table.attach(label_note,0,1,10,11)
	table.attach(entry_note,1,2,10,11)

	bbox =Gtk::HBox::new(FALSE, 10)
	bbox.border_width=10
	bbox.show

	ok_button = Gtk::Button.new(Gtk::Stock::OK)
	ok_button.show
	ok_button.signal_connect("clicked") {
		if add_boolean
			#new entry!
				if !Contact::contact_exist?(entry_fname.text(),entry_lname.text())
					Contact::add_contact(entry_fname.text(), entry_lname.text(), entry_email.text(), entry_phone.text(),  entry_mobile.text(),  entry_pager.text(), entry_im.text(), entry_title.text(), entry_organization.text(), entry_location.text(), entry_note.text())
				   iter = @contact_view.model.append
				   iter[0] = entry_fname.text()
				   iter[1] = entry_lname.text()
					window.destroy 
				else
   				dialog = Gtk::MessageDialog.new(window, Gtk::Dialog::DESTROY_WITH_PARENT,
                             Gtk::MessageDialog::ERROR,
                             Gtk::MessageDialog::BUTTONS_OK,
                             "Contact '#{entry_fname.text()} #{entry_lname.text()}' already exists!")
					dialog.run
					dialog.destroy
				end
			else
				#modify existing entry				
				Contact::set_email(entry_fname.text(),entry_lname.text(),entry_email.text())
				Contact::set_phone(entry_fname.text(),entry_lname.text(),entry_phone.text())
				Contact::set_mobile(entry_fname.text(),entry_lname.text(),entry_mobile.text())
				Contact::set_pager(entry_fname.text(),entry_lname.text(),entry_pager.text())
				Contact::set_im(entry_fname.text(),entry_lname.text(),entry_im.text())
				Contact::set_title(entry_fname.text(),entry_lname.text(),entry_title.text())
				Contact::set_organization(entry_fname.text(),entry_lname.text(),entry_organization.text())
				Contact::set_location(entry_fname.text(),entry_lname.text(),entry_location.text())
				Contact::set_note(entry_fname.text(),entry_lname.text(),entry_note.text())
				
			  	# @contact_view.each do |model,path,iter|
				#	if (iter[0] == entry_fname.text()) && (iter[1] == entry_lname.text())
				#		break
				#	end
				#end
				window.destroy 
			end
	}

	cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
	cancel_button.show
	cancel_button.signal_connect("clicked") {
		window.destroy
	}

	ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	bbox.pack_start(ok_button, TRUE, TRUE, 0)
	cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	bbox.pack_start(cancel_button, TRUE, TRUE, 0)		
	vbox.add table
	separator = Gtk::HSeparator::new()
	separator.show
	vbox_root.pack_start(separator, FALSE, TRUE, 0)
	vbox_root.pack_start(bbox, FALSE, TRUE, 0)
	window.show
  end

  def fill_contact_entry()
	window=Gtk::Window.new
	window.set_modal(true)

   	window.set_title("Fill Contact using LDAP directory")
   	window.set_size_request(360, 240)

	window.signal_connect("key_press_event") {|w,e|
        	if e.keyval == Gdk::Keyval::GDK_Escape
			window.destroy
	        end
   	}

	frame = Gtk::Frame::new
	frame.border_width=10
	frame.show
	vbox_root=Gtk::VBox::new
	vbox_root.show
	window.add vbox_root
	vbox_root.add frame

	vbox = Gtk::VBox.new
	vbox.show
	frame.add vbox

	table = Gtk::Table.new(3,2,false)
	table.show

	label_host = Gtk::Label.new "Host"
	label_host.show
	entry_host = Gtk::Entry.new			
	entry_host.show
	table.attach(label_host,0,1,0,1)
	table.attach(entry_host,1,2,0,1)

	label_port = Gtk::Label.new "Port"
	label_port.show
	entry_port = Gtk::Entry.new
	entry_port.set_text(LDAP::LDAP_PORT.to_s)
	entry_port.show
	table.attach(label_port,0,1,1,2)
	table.attach(entry_port,1,2,1,2)

	label_base = Gtk::Label.new "Base"
	label_base.show
	entry_base = Gtk::Entry.new			
	entry_base.show
	table.attach(label_base,0,1,2,3)
	table.attach(entry_base,1,2,2,3)
	

	bbox =Gtk::HBox::new(FALSE, 10)
	bbox.border_width=10
	bbox.show

	ok_button = Gtk::Button.new(Gtk::Stock::REFRESH)
	ok_button.show
	ok_button.signal_connect("clicked") {
		host = entry_host.text
		port = entry_port.text
		#SSLPORT = LDAP::LDAPS_PORT
		base = entry_base.text
		if host!="" && port!="" && base!=""
		   scope = LDAP::LDAP_SCOPE_SUBTREE
		   filter = '(objectclass=person)'
		   attrs = ['cn', 'sn', 'givenName', 'mail', 'telephoneNumber', 'mobile', 'title', 'o']

		   begin
			   Thread.start {
			      conn = LDAP::Conn.new(host, port.to_i)
			      #conn.bind(dn=nil, password=nil, method=LDAP::LDAP_AUTH_SIMPLE)
			      #conn.perror("bind")
			      conn.search(base, scope, filter, attrs) { |entry|
				 # print distinguished name
				 #p entry.dn
				 # print all attribute names
				 #p entry.attrs
				 # print values of attribute 'sn'
				 # print entry as Hash
				 $log.debug(entry.to_hash)
				 firstname=entry.to_hash["givenName"]
				 lastname=entry.to_hash["sn"]
				 #seems all values are returned in an array
				 if firstname && lastname && !Contact::contact_exist?(firstname.first, lastname.first)
					 Contact::add_contact(firstname.first, lastname.first, (entry.to_hash["mail"] && entry.to_hash["mail"].first) || "", (entry.to_hash["telephoneNumber"] && entry.to_hash["telephoneNumber"].first) || "",  (entry.to_hash["mobile"] && entry.to_hash["mobile"].first) || "",  "", "", (entry.to_hash["title"] && entry.to_hash["title"].first) || "", (entry.to_hash["o"] && entry.to_hash["o"].first) || "", "", "")
					 Gtk.thread_protect do
					 	if @contact_view
				   	      		iter = @contact_view.model.append
				   	      		iter[0] = firstname.first
					      		iter[1] = lastname.first
					 	end
					 end
				 end
			   }
		   }
		   rescue LDAP::ResultError
			   $log.error("Can't search for contact with given arguments")
		   rescue Exception => msg
			   $log.error("LDAP searching error #{msg}")
		   end
		   #conn.perror("search")
		   #conn.unbind
		end
	}

	cancel_button = Gtk::Button.new(Gtk::Stock::CLOSE)
	cancel_button.show
	cancel_button.signal_connect("clicked") {
		window.destroy
	}

	ok_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	bbox.pack_start(ok_button, TRUE, TRUE, 0)
	cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT)
	bbox.pack_start(cancel_button, TRUE, TRUE, 0)		
	vbox.add table
	separator = Gtk::HSeparator::new()
	separator.show
	vbox_root.pack_start(separator, FALSE, TRUE, 0)
	vbox_root.pack_start(bbox, FALSE, TRUE, 0)
	window.show
  end

  def del_selected_contact_entry(win)
	if @contact_view.selection.selected
		firstname=@contact_view.selection.selected[0]
		lastname=@contact_view.selection.selected[1]
		if !Contact::used?(firstname, lastname)
		    @contact_view.model.remove(@contact_view.selection.selected)
    		    Contact::del_contact(firstname, lastname)
		    if Contact::contact_nb_entry() == 0
			    if @cb_mail
	    			@cb_mail.set_sensitive(false)
			    	@cb_im.set_sensitive(false)
				@cb_sms.set_sensitive(false)
	    			@entry_mail_button.set_sensitive(false)
				@entry_im_button.set_sensitive(false)
				@entry_sms_button.set_sensitive(false)
			    end
		    end
		else
			errorEntry(win, "Contact #{firstname} #{lastname} is in used #{$contact["#{firstname}|#{lastname}"].nb_use} time(s)")
		end
	end
  end

  @contact_view.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Delete
	del_selected_contact_entry(window)
    elsif e.keyval == Gdk::Keyval::GDK_Insert
	add_contact_entry()
    end
    }
	@contact_view.signal_connect("button_press_event") do |widget, event|
	  if (@contact_view.selection.selected!=nil) && (event.event_type == Gdk::Event::BUTTON2_PRESS)
		edit_contact_entry(@contact_view.selection.selected)
	  end
	end

	
	#load existing entries
	$contact.each_key {|id|
		iter=@contact_view.model.append
		iter[0] = $contact[id].firstname
		iter[1] = $contact[id].lastname
	} unless !$contact

	# Create a popup menu
	menu_contact = Gtk::Menu.new

	item_add_contact = Gtk::ImageMenuItem.new("Add contact")
 	image_item_add_contact = Gtk::Image.new()
 	image_item_add_contact.set_stock(Gtk::Stock::ADD)
	item_add_contact.set_image(image_item_add_contact)
	item_add_contact.signal_connect("activate") {
		add_contact_entry()
	}
	menu_contact.append(item_add_contact)

	item_del_contact = Gtk::ImageMenuItem.new("Delete contact")
 	image_item_del_contact = Gtk::Image.new() 
 	image_item_del_contact.set_stock(Gtk::Stock::REMOVE) 
	item_del_contact.set_image(image_item_del_contact)
	item_del_contact.signal_connect("activate") {|renderer, iter, var|
		del_selected_contact_entry(window)	
	}
	menu_contact.append(item_del_contact)

	item_edit_contact = Gtk::ImageMenuItem.new("Edit contact")
 	image_item_edit_contact = Gtk::Image.new() 
 	image_item_edit_contact.set_stock(Gtk::Stock::EDIT) 
	item_edit_contact.set_image(image_item_edit_contact)
	item_edit_contact.signal_connect("activate") {
		if @contact_view.selection.selected != nil
			edit_contact_entry(@contact_view.selection.selected) 
		end
	}
	menu_contact.append(item_edit_contact)

	item_fill_contact = Gtk::ImageMenuItem.new("Fill contact using LDAP")
 	image_item_fill_contact = Gtk::Image.new() 
 	image_item_fill_contact.set_stock(Gtk::Stock::COPY) 
	item_fill_contact.set_image(image_item_fill_contact)
	item_fill_contact.signal_connect("activate") {
		fill_contact_entry() 
	}
	if $ldap_library_missing
		item_fill_contact.set_sensitive(false)
	end
	menu_contact.append(item_fill_contact)

	menu_contact.show_all

	@contact_view.signal_connect("button_press_event") do |widget, event|
		if event.kind_of? Gdk::EventButton and event.button == 3
			if @contact_view.selection.selected
				item_del_contact.set_sensitive(true)
				item_edit_contact.set_sensitive(true)
			else
				item_del_contact.set_sensitive(false)
				item_edit_contact.set_sensitive(false)
			end	
			menu_contact.popup(nil, nil, event.button, event.time)
		end
	end

	hbox = Gtk::HBox.new(FALSE, 1)
	hbox.add Gtk::Image.new(Gtk::Stock::ORIENTATION_PORTRAIT, Gtk::IconSize::MENU)
	hbox.add Gtk::Label::new("Contact")
	hbox.show_all

  	scrollhbox = Gtk::HBox::new
  	scrollhbox.show
  	scrollhbox.add(@contact_view)
  
	scrolled = Gtk::ScrolledWindow.new(nil, nil)
	scrolled.border_width=0
	scrolled.set_policy(Gtk::POLICY_NEVER,Gtk::POLICY_AUTOMATIC)
	scrolled.add_with_viewport(scrollhbox) 
	scrolled.show
  
	vbox.add(scrolled)	
	notebook.append_page frame_contact, hbox
