require "#{GNMSLIB}"+'/monitor/client/snmp/snmp'

class SnmpMonitoring
   attr_accessor :oidref, :threshold

	TESTOP=["=", "!=", "<", ">"]

   def initialize (st, oidref_name, op, th, sev)
	@state=st
      @oidref=oidref_name
      @oper=op
      @threshold=th
		#index of $status
	   @severity=sev
   end
	
	def oper()
		return TESTOP[@oper]
	end

	def get_state()
		return @state
	end

	def active?()
		return @state==1
	end  
	#
	#	compute the value
	#
	def value(manager, node)
		if node != nil
			strcalc=$oid_refs[@oidref].value.dup
			strcalctp=strcalc.split(/\+/)
			for oidref in strcalctp
				begin
					response=manager.get(oidref)
				rescue Exception => msg
					$log.error("Exception could not request get SNMP for #{oidref}: #{msg}")
					raise
					return
				end
      				response.each_varbind do |vb|
					strcalc.gsub!(oidref,vb.value.to_s)
		   		end
			end
		  return strcalc
		end
	end

	def raw_severity()
		return @severity
	end

	def severity()
		return $status[@severity]
	end
end #class
