require "#{GNMSLIB}"+'/monitor/client/wmi/wmi'

class WmiMonitoring
   attr_accessor :wmiref, :value

	TESTOP=["=", "!=", "<", ">","Contain","Not contain"]

   def initialize (st, wmiref_name, op, th, sev)
	@state=st
	@wmiref=wmiref_name
	@oper=op
	@value=th
	#index of $status
	@severity=sev
   end
	
	def oper()
		return TESTOP[@oper]
	end

	def get_state()
		return @state
	end

	def active?()
		return @state==1
	end

	#
	#	compute the value
	#
	def request(node)
		if node != nil
			wmiref=$wmi_refs[@wmiref].value.dup
			if node.get_account_id("wmi")
				begin
  	 				login, password = node.get_account_id("wmi")
					resultt=wmi_request(login, password, node.ip, wmiref)
					if resultt.size() > 0
						return resultt
					end
				rescue Exception => msg
					$log.error("Exception WMI request for #{wmiref}: #{msg}")
					raise
				end
			else
				$log.error("wmi login/password not set for host #{node.ip}")
			end
		end
		return nil
	end

	def raw_severity()
		return @severity
	end

	def severity()
		return $status[@severity]
	end
end #class
