class CustomPlugin

  def initialize(node=nil)
	#index in $status
	  @event_state=nil
	  @event_description=nil
	  @node=node
	  monitor()
  end

   def get_node()
	   return @node
   end

  def get_event_state()
	  return $status[@event_state]
  end

  def get_event_state_raw()
	  return @event_state
  end

  def get_event_description()
	  return @event_description
  end

#
# state is one of "CRITICAL", "MAJOR", "MINOR","WARNING", 
# "NORMAL", "UNMANAGED", "UNKNOWN"
#
  def set_state(state, description=nil)
		@event_state=$status.index(state)
		if @event_state == nil
			#init @event_state to UNKNOWN
			@event_state=$status.size()-1
		end
		if description != nil
			@event_description=description
		end
  end

  def CustomPlugin::show_description()
		dialog = Gtk::MessageDialog.new($win, Gtk::Dialog::MODAL,
                           	 Gtk::MessageDialog::INFO,
                           	 Gtk::MessageDialog::BUTTONS_OK,
                           	 description())
		dialog.signal_connect('response') { dialog.destroy }
		dialog.show
  end
end
