class MsgBuffer

  #nitems method does not exist anymore in ruby 1.9.3
  def nitems_local(arr)
    cpt = 0
    arr.each {|val|
      if val
         cpt+=1
      end
    }
    return cpt
  end

  def initialize(size)
    @buff = Array.new()
    @size=size
  end
  
  def put(msg)
    @buff.unshift(msg)
    #puts "message put nitems=" + nitems_local(@buff).to_s
  end
  
  def get()
    return @buff.pop
  end
  
  def has_more?
    nitems_local(@buff) != 0
  end
  
  def full?
    nitems_local(@buff) >= @size
  end

  def empty?
	  return  nitems_local(@buff) == 0
  end
end
