#
#	str -> boolean
#

class String
        def ascii(replacement="")
           self.gsub(/[\x00-\x09]|[\x0b\x0c]|[\x0e\x1f]|[\x80-\xff]/, replacement)
        end
	
	def to_b()
 	 return self == "true"  
	end
end

def i2b(i)
	if (i == "1") || (i == 1)
		return true
	else
		return false
	end
end

def b2i(bool)
	if bool == true
		return 1
	else
		return 0
	end
end

#
#	return true if arg is an ip addr
#	need: an arg
#
def isValidIPv4(ip)
  if ip.nil?
    return false
  end
  lip = ip.split(/\./)
  if lip.size != 4
     return false
  end
  lip.each do |val|
	if !isInteger(val) || (val.to_i > 255 || val.to_i < 0)
		return false
	end
  end
  return true
end

#
#	return true if fixnum arg is a valid port
#
def isValidPort(port)
	if isInteger(port.to_s())
		if (port>0) && (port<65535)
			return true
		end
	end
	return false
end

def isValidMac(mac)
  if mac.nil?
    return false
  end
  lmac = mac.split(/:/)
  if lmac.size != 6
     return false
  end
  lmac.each do |val|
    val_dec = val.to_i(16)
    if (val.length != 2) || (val_dec > 255 || val_dec < 0)
	return false
    end
  end
  return true
end

#
#	return true if arg is an integer
#	need: an arg
#
def isInteger(str)
	begin
		return str.match(/^\d+$/)
	rescue
		if str.class == Fixnum
			return true
		else
			return false
		end
	end
end

#
#	return true if arg is a double
#	need: an arg
#
def isDouble(str)
	return str.match(/^\d+\.\d+$/)
end
