#
# provide help window
#
#

def help_window
  window = Gtk::Window.new
  window.set_size_request(500,300)
  window.set_title "Help"
  icon_name="#{PIXMAP_PATH}/logo_icon.png"
  Gtk::Window.set_default_icon(icon_name)
  window.show

  vbox = Gtk::VBox.new
  vbox.show
  window.add vbox

  text = Gtk::TextView.new
  text.cursor_visible=false
  text.set_size_request(350,300)
  text.set_editable(false)
  text.show

  scrolled_window = Gtk::ScrolledWindow.new(nil, nil)
  scrolled_window.border_width=2
  scrolled_window.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)  

  vbox.pack_start(scrolled_window, true, true, 0)
  scrolled_window.show
  scrolled_window.add(text)

  text.grab_focus
  readme_file = "#{GNMSLIB}/../README"
  if FileTest.exist?(readme_file)
   fic = File.new(readme_file,'r')
   tlign = fic.readlines
   fic.close
   text.buffer.insert_at_cursor(tlign.join)
  else
    text.buffer.insert_at_cursor("Error: Could not find README file")
  end
  window.signal_connect("key_press_event") {|w,e|
	 if e.keyval == Gdk::Keyval::GDK_Escape
   	window.destroy
	 end
  }
end
