class NodeNetworkProperty

  def initialize (node)

  window=Gtk::Window.new
  @window=window
  
  window.set_transient_for($win)
  window.set_title("Network property of "+node.ip+"/#{node.netmask}")
  window.set_size_request(480, 520)
  window.set_modal(true)
  vboxb = Gtk::VBox::new
  window.add vboxb
  vboxb.show	
  window.signal_connect("key_press_event") {|w,e|
    if e.keyval == Gdk::Keyval::GDK_Escape
      window.destroy
    end
  }

  notebook = Gtk::Notebook::new()
  notebook.set_tab_pos(Gtk::POS_TOP)
  vboxb.add notebook
  notebook.show

########################## status tab ###############

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.set_size_request(300, 390)
  frame.show
  vbox = Gtk::VBox::new(false,2)
  vbox.show
  frame.add vbox 

  frame_st=Gtk::Frame.new("General")
  frame_st.border_width=10
  table_st = Gtk::Table.new(1,3,false)
  table_st.show
  label_percent = Gtk::Label.new("Current")
  label_percent.show
  #label_nbhost = Gtk::Label.new
  #label_nbhost.show
  entry_status = Gtk::Entry.new
  rgb=hexa_to_rgb_color($status_color[$status_value[node.status]])
  tstyle=Gtk::Style.new
  tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
  entry_status.set_style(tstyle)
  entry_status.set_text($status[$status_value[node.status]])

  entry_status.set_size_request(100,-1)
  entry_status.set_xalign(0.5);
  entry_status.set_editable false
  entry_status.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_status
  table_st.attach(label_percent,0,1,0,1)
  #table_st.attach(label_nbhost,1,2,0,1)
  table_st.attach(bbox,1,2,0,1)
  frame_st.add table_st
  frame_st.show
  vbox.add frame_st
  frame_dt_label="Inner node detail by status"

  if node.nb_node > 0
	 frame_dt=Gtk::Frame.new(frame_dt_label)
	 frame_dt.border_width=10

	 if !$defined_lib_gruff

	 refresh_node_sev_display=Thread.start {
		old_table=nil
		while (window != nil) do
	 		table = Gtk::Table.new(3,3,false)
	 		table.show
			begin
	 		#do stat for each internal node network severity
	 		sev_stat=Array.new($status_value.size,0)
    	 		tstyle=Gtk::Style.new
	 		rgb=hexa_to_rgb_color($status_color[$status_value[node.status]])
	 		tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
	 		entry_status.set_style(tstyle)
			entry_status.set_text($status[$status_value[node.status]])

	 		#refresh number of host
	 		if node.nb_node > 1
				frame_dt.label=frame_dt_label + " ("+node.nb_node.to_s()+ " nodes found)"
	 		end
			node.get_node().each_value do |n|
				sev_stat[$status_value.index(n.status)]+=1
			end

			status_index=0
			$status.each do |stat|
		 		entry_sev = Gtk::Entry.new
		  		tstyle=Gtk::Style.new
					
		  		rgb=hexa_to_rgb_color($status_color[status_index])
			  	tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
			  	entry_sev.set_style(tstyle)
   	  			label_sev = Gtk::Label.new(sev_stat[status_index].to_s()+" node(s)")
   	  			label_sev.show
			  	sev_percent=0
			  	if node.nb_node>0
					 sev_percent=(sev_stat[status_index]*100)/node.nb_node.to_f()
			  	end
			  	label_sev_percent = Gtk::Label.new(sev_percent.round().to_s()+" %")
			  	label_sev_percent.show
		  		entry_sev.set_text(stat)
			  	entry_sev.set_size_request(100,-1)
			  	entry_sev.set_xalign(0.5);
			  	entry_sev.set_editable false
		  		entry_sev.show
			  	bbox=Gtk::HButtonBox.new
			  	bbox.show
			  	bbox.add entry_sev
		  		if sev_stat[status_index] > 0
					table.attach(label_sev_percent,0,1,status_index,status_index+1)
					table.attach(label_sev,1,2,status_index,status_index+1)
					table.attach(bbox,2,3,status_index,status_index+1)
			  	end
		  		status_index+=1
			end
		 	if old_table != nil 
				frame_dt.remove old_table
		  	end
		  	frame_dt.add table
	  		sleep(10)
		  	old_table=table
			rescue Exception => msg
				$log.debug("Exception in refresh_node_sev_display for #{node.ip}: #{msg}")
			end
	  end
	 }

	 else
		refresh_node_sev_display=Thread.start {
		old_vbox=nil
			while (window != nil) do
				begin
		  		tstyle=Gtk::Style.new
				rgb=hexa_to_rgb_color($status_color[$status_value[node.status]])
				tstyle.set_base(Gtk::STATE_NORMAL, rgb.red, rgb.green, rgb.blue)
				entry_status.set_style(tstyle)
				entry_status.set_text($status[$status_value[node.status]])
				#refresh number of host
				if node.nb_node > 1
					frame_dt.label=frame_dt_label + " ("+node.nb_node.to_s()+ " nodes found)"
				end

	        		loader=Gdk::PixbufLoader.new
		  		loader.last_write(network_status_pie(node, 400)) 
		  		pix = loader.pixbuf
		  		img=Gtk::Image.new(pix)
        			img.show
		  		vbox_img=Gtk::VBox.new
				vbox_img.show
		  		vbox_img.add img
		  		if old_vbox != nil
			  		frame_dt.remove old_vbox
		  		end
		  		frame_dt.add vbox_img
		  		sleep(10)
		  		old_vbox=vbox_img
				rescue Exception => msg
					$log.debug("Exception in refresh_node_sev_display for #{node.ip}: #{msg}")
				end
			end
		}
	 end

	 frame_dt.show
	 vbox.add frame_dt
  end
	hbox = Gtk::HBox.new(FALSE, 1)
	hbox.add Gtk::Image.new(Gtk::Stock::DIALOG_WARNING, Gtk::IconSize::MENU)
	hbox.add Gtk::Label::new("Status")
	hbox.show_all
  notebook.append_page frame, hbox

###############

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.set_size_request(300, 390)
  frame.show

  table = Gtk::Table.new(10,2,false)
  table.show
  vbox = Gtk::VBox.new
  vbox.show
  frame.add vbox
  vbox.add table

  label_icon = Gtk::Label.new "Icon"
  label_icon.show
  entry_type =  Gtk::ImageComboList.new("type", "#{node.type}")
  entry_type.set_size_request(200,-1)
  entry_type.show

  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_type

  table.attach(label_icon,0,1,0,1)
  table.attach(bbox,1,2,0,1)

  label_xy = Gtk::Label.new "X:Y"
  label_xy.show
  entry_x = Gtk::Entry.new
  entry_x.set_editable false
  entry_x.set_text("#{node.x.to_i}")
  entry_x.set_size_request(96,-1)
  entry_x.set_max_length 4
  entry_x.show
  bbox=Gtk::HButtonBox.new
  bbox.set_layout_style Gtk::ButtonBox::EDGE
  bbox.show
  bbox.add entry_x
  table.attach(label_xy,0,1,1,2)

  entry_y = Gtk::Entry.new
  entry_y.set_editable false
  entry_y.set_text("#{node.y.to_i}")
  entry_y.set_size_request(96,-1)
  entry_y.set_max_length 4
  entry_y.show

  bbox.add entry_y

  table.attach(bbox,1,2,1,2,Gtk::EXPAND)
  label_ip = Gtk::Label.new "IP"
  label_ip.show
  entry_ip = Gtk::Entry.new
  entry_ip.set_editable false
  entry_ip.set_text(node.ip)
  entry_ip.set_size_request(200,-1)
  entry_ip.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_ip

  table.attach(label_ip,0,1,2,3)
  table.attach(bbox,1,2,2,3)

  label_mask = Gtk::Label.new "Mask"
  label_mask.show
  entry_mask = Gtk::Entry.new
  entry_mask.set_text(node.netmask.to_s) unless node.netmask == nil
  entry_mask.set_size_request(200,-1)
  entry_mask.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_mask

  table.attach(label_mask,0,1,3,4)
  table.attach(bbox,1,2,3,4)

  label_map = Gtk::Label.new "Network"
  label_map.show
  entry_map = Gtk::Entry.new
  entry_map.set_editable false
  if node.map == nil
	entry_map.set_sensitive(false)
	entry_map.set_sensitive(false)
	entry_map.set_text("ROOT")
  else
	entry_map.set_text(node.map)
  end
  entry_map.set_size_request(200,-1)
  entry_map.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_map
  table.attach(label_map,0,1,4,5)
  table.attach(bbox,1,2,4,5)

  label_name = Gtk::Label.new "Name"
  label_name.show
  entry_name = Gtk::Entry.new
  entry_name.set_text(node.name) unless node.name == nil
  entry_name.set_size_request(200,-1)
  entry_name.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_name

  table.attach(label_name,0,1,5,6)
  table.attach(bbox,1,2,5,6)

  label_dname = Gtk::Label.new "Domain Name"
  label_dname.show
  entry_dname = Gtk::Entry.new
  entry_dname.set_text(node.dns_domain) unless node.dns_domain == nil
  entry_dname.set_size_request(200,-1)
  entry_dname.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_dname
  table.attach(label_dname,0,1,6,7)
  table.attach(bbox,1,2,6,7)

  label_netbiosname = Gtk::Label.new "Netbios Group"
  label_netbiosname.show
  entry_netbiosname = Gtk::Entry.new
  entry_netbiosname.set_text(node.netbios_domain) unless node.netbios_domain == nil
  entry_netbiosname.set_size_request(200,-1)
  entry_netbiosname.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_netbiosname

  table.attach(label_netbiosname,0,1,7,8)
  table.attach(bbox,1,2,7,8)
  label_os = Gtk::Label.new "OS"
  label_os.show
  entry_os =  Gtk::ImageComboList.new("os", "#{node.os}")
  entry_os.set_size_request(200,-1)
  entry_os.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_os

  table.attach(label_os,0,1,8,9)
  table.attach(bbox,1,2,8,9)
  label_desc = Gtk::Label.new "Description"
  label_desc.show
  entry_desc = Gtk::Entry.new
  entry_desc.set_text(node.description)
  entry_desc.set_size_request(200,-1)
  entry_desc.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add entry_desc

  table.attach(label_desc,0,1,9,10)
  table.attach(bbox,1,2,9,10)

  hbox = Gtk::HBox.new(FALSE, 1)
  hbox.add Gtk::Image.new(Gtk::Stock::INFO, Gtk::IconSize::MENU)
  hbox.add Gtk::Label::new("Information")
  hbox.show_all
  notebook.append_page frame, hbox

###############SNMP tab################################

  frame = Gtk::Frame::new("Configuration")
  frame.border_width=10
  frame.set_size_request(300, 390)
  frame.show
  table = Gtk::Table.new(6,2,false)
  table.show
  frame.add table
  
  label_snmp_version = Gtk::Label.new "SNMP version"
  label_snmp_version.show
  combo_snmp_version = Gtk::ComboBox.new
  combo_snmp_version.append_text(SNMPv1)
  combo_snmp_version.append_text(SNMPv2)
  val=nil
	if node.ip == ROOTMAPADDR
	 val=$config.snmp_version
	 combo_snmp_version.set_sensitive false
	else
	 val=node.snmp_version
	end
	if val==SNMPv1
   	combo_snmp_version.set_active(0)
	else
   	combo_snmp_version.set_active(1)
	end
  combo_snmp_version.set_size_request(100,-1)
  combo_snmp_version.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add combo_snmp_version
  
  table.attach(label_snmp_version,0,1,0,1)
  table.attach(bbox,1,2,0,1)  
  
  label_snmp_port = Gtk::Label.new "Port"
  label_snmp_port.show
  if node.ip == ROOTMAPADDR
    adj = Gtk::Adjustment::new($config.snmp_port.to_f, 1.0, 65534.0, 1.0, 5.0, 0.0)
    port_spinner = Gtk::SpinButton::new(adj, 0, 0)
    port_spinner.set_sensitive false
  else
    adj = Gtk::Adjustment::new(node.snmp_port.to_f, 1.0, 65534.0, 1.0, 5.0, 0.0)
    port_spinner = Gtk::SpinButton::new(adj, 0, 0)
  end
  port_spinner.set_wrap(true)
  port_spinner.show  
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add port_spinner
  
  table.attach(label_snmp_port,0,1,1,2)
  table.attach(bbox,1,2,1,2)  
  
  label_snmp_timeout = Gtk::Label.new "Timeout (in s)"
  label_snmp_timeout.show
  if node.ip == ROOTMAPADDR
   adj = Gtk::Adjustment::new($config.snmp_timeout.to_f, 1.0, 3600.0, 1.0, 5.0, 0.0)
   timeout_spinner = Gtk::SpinButton::new(adj, 0, 0)
	timeout_spinner.set_sensitive false
  else
    adj = Gtk::Adjustment::new(node.snmp_timeout.to_f, 1.0, 3600.0, 1.0, 5.0, 0.0)
    timeout_spinner = Gtk::SpinButton::new(adj, 0, 0)
  end
  timeout_spinner.set_wrap(true)
  timeout_spinner.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add timeout_spinner
  
  table.attach(label_snmp_timeout,0,1,2,3)
  table.attach(bbox,1,2,2,3) 
  
  label_snmp_retry = Gtk::Label.new "Retry"
  label_snmp_retry.show
  if node.ip == ROOTMAPADDR
   adj = Gtk::Adjustment::new($config.snmp_retry.to_f, 1.0, 3600.0, 1.0, 5.0, 0.0)
   retry_spinner = Gtk::SpinButton::new(adj, 0, 0)
	retry_spinner.set_sensitive false
  else
    adj = Gtk::Adjustment::new(node.snmp_retry.to_f, 1.0, 3600.0, 1.0, 5.0, 0.0)
    retry_spinner = Gtk::SpinButton::new(adj, 0, 0)
  end  
  retry_spinner.set_wrap(true)
  retry_spinner.show
  bbox=Gtk::HButtonBox.new
  bbox.show
  bbox.add retry_spinner
  
  table.attach(label_snmp_retry,0,1,3,4)
  table.attach(bbox,1,2,3,4) 

	hbox = Gtk::HBox.new(FALSE, 1)
	hbox.add Gtk::Image.new(Gtk::Stock::EDIT, Gtk::IconSize::MENU)
	hbox.add Gtk::Label::new("SNMP")
	hbox.show_all
  notebook.append_page frame, hbox

#### account tab ########################################

eval IO.read("#{GNMSLIB}"+'/gui/sub/account_frame.rb')

#### ALERT TAB from config_window.rb modified to be adapted to the node ####################

  frame = Gtk::Frame::new("Notification based security level")
  frame.border_width=10
  frame.set_size_request(200, 150)
  frame.show
 
  @entry_level = Gtk::ComboBox.new
	for l in $LEVEL
	  @entry_level.append_text(l)
	end
  @entry_level.set_active(0)
  @old_sev_level=@entry_level.active_text
  @entry_level.show

  bbox=Gtk::VButtonBox.new
  bbox.show

  #add button from inherit from general conf
  inherit_conf_cb=Gtk::CheckButton.new("Inherit general configuration")
  inherit_conf_cb.show
  inherit_conf_cb.set_active(node.inherit_from_global)
  @entry_level.set_sensitive(!node.inherit_from_global)

  bbox.add inherit_conf_cb
  bbox.add @entry_level
  frame.add bbox

  chbutton = []
  
  for alert_type in $talert_type
    pos=$talert_type.index(alert_type)
    cb_t=Gtk::CheckButton.new alert_type.capitalize()
    cb_t.set_active(node.alert_type_by_level[@entry_level.active_text][pos])
    cb_t.set_sensitive(!inherit_conf_cb.active?)
    cb_t.show
    chbutton.push cb_t    	
	if alert_type == "mail"
		cb_t.set_label("Mail recipient")		
		@entry_mail = []
		@entry_mail_button = Gtk::Button.new("Configure contacts")
		if node.mail_by_level[@entry_level.active_text]
   	 		@entry_mail=node.mail_by_level[@entry_level.active_text]
		end
		if @entry_mail.size > 0
			contact_str="Selected contact(s):\n"
			@entry_mail.each {|contact|
				contact_str+=contact.firstname+" "+contact.lastname+"\n"
			}
			@entry_mail_button.set_tooltip_text(contact_str)
		end

		@entry_mail_button.signal_connect("clicked") {
			ConfigWindow::contact_selection_window("Mail",@entry_mail,@entry_mail_button)
		}
		
		@entry_mail_button.show	
		
		bhbox_mail=Gtk::HButtonBox.new
		bhbox_mail.add cb_t
		bhbox_mail.add @entry_mail_button
		bhbox_mail.show
		@cb_mail=cb_t
		@cb_mail.set_sensitive($config.mail_server && !node.inherit_from_global)
		@entry_mail_button.set_sensitive(!node.inherit_from_global && cb_t.active? && $config.mail_server && (Contact::contact_nb_entry()>0))
		bbox.add bhbox_mail		
	elsif alert_type == "beep"
		label_soundfile = Gtk::Label.new "Sound file"
		label_soundfile.show
		@entry_soundfile = Gtk::ComboBox.new
		@entry_soundfile.set_size_request 140,-1
		files_tmp=Dir.entries(SOUND_DIR)
		files_tmp << ConfigGlobal::DEFAULT_SOUND_FILE

		files=Array.new
		files_tmp.each do |val|
			if val.match('[^.]')
				files << val
				@entry_soundfile.append_text(val)
			end
		end
		current_level=@entry_level.active_text
		if node.sound_file_path_by_level[current_level] != nil
			iter=files.index(node.sound_file_path_by_level[current_level])
			if iter == nil
				@entry_soundfile.set_active(files.size()-1)
			else
				@entry_soundfile.set_active(iter)
			end
		else
			@entry_soundfile.set_active(files.size()-1)
		end
		@entry_soundfile.show
		hbox_sound=Gtk::HBox.new
		bhbox_sound_file=Gtk::HButtonBox.new
		bhbox_sound_file.add label_soundfile
		bhbox_sound_file.add @entry_soundfile
		bhbox_sound_file.set_sensitive(cb_t.active? && !node.inherit_from_global)
		cb_t.set_sensitive(!node.inherit_from_global)
		bhbox_sound_file.show
		hbox_sound.add cb_t
		hbox_sound.add bhbox_sound_file
		hbox_sound.show
		bbox.add hbox_sound
	elsif alert_type == "sms"
		cb_t.set_label("SMS mobile number")
		@entry_sms = []
		@entry_sms_button = Gtk::Button.new("Configure contacts")
		if node.sms_num_by_level[@entry_level.active_text]
			@entry_sms=node.sms_num_by_level[@entry_level.active_text]
		end
		if @entry_sms.size > 0
			contact_str="Selected contact(s):\n"
			@entry_sms.each {|contact|
				contact_str+=contact.firstname+" "+contact.lastname+"\n"
			}
			@entry_sms_button.set_tooltip_text(contact_str)
		end		
		@entry_sms_button.signal_connect("clicked") {
			ConfigWindow::contact_selection_window("SMS",@entry_sms,@entry_sms_button)
		}
		@entry_sms_button.show		
		bhbox_sms=Gtk::HButtonBox.new
		bhbox_sms.add cb_t
		bhbox_sms.add @entry_sms_button
		bhbox_sms.show
		@cb_sms=cb_t
		@cb_sms.set_sensitive(!node.inherit_from_global && ($config.sms_device != ""))
		@entry_sms_button.set_sensitive(!node.inherit_from_global && cb_t.active? && (Contact::contact_nb_entry()>0) && ($config.sms_device != ""))
		bbox.add bhbox_sms
	elsif alert_type == "im"
		cb_t.set_label("IM Recipient")
		@entry_im = []
		@entry_im_button = Gtk::Button.new("Configure contacts")		
		if node.im_dest_by_level[$config.level]
			@entry_im=node.im_dest_by_level[@entry_level.active_text]
		end
		if @entry_im.size > 0
			contact_str="Selected contact(s):\n"
			@entry_im.each {|contact|
				contact_str+=contact.firstname+" "+contact.lastname+"\n"
			}
			@entry_im_button.set_tooltip_text(contact_str)
		end		
		@entry_im_button.signal_connect("clicked") {
			ConfigWindow::contact_selection_window("IM",@entry_im,@entry_im_button)
		}
		@entry_im_button.show
	
		bhbox_im=Gtk::HButtonBox.new
		bhbox_im.add cb_t
		bhbox_im.add @entry_im_button
		bhbox_im.show
		@cb_im=cb_t
		@cb_im.set_sensitive($config.im_daemon && !node.inherit_from_global)
		@entry_im_button.set_sensitive(!node.inherit_from_global && cb_t.active? && $config.im_daemon  && (Contact::contact_nb_entry()>0))
		bbox.add bhbox_im			
	elsif alert_type == "script"
		cb_t.set_label("Script path to execute")	
		@entry_script = Gtk::Entry.new
		@entry_script.show
		if node.script_name_by_level != nil && node.script_name_by_level[@entry_level.active_text] != nil
			@entry_script.set_text(node.script_name_by_level[@entry_level.active_text])
		end				
		bhbox_script=Gtk::HButtonBox.new
		bhbox_script.add cb_t
		bhbox_script.add @entry_script
		bhbox_script.show
		@entry_script.set_sensitive(cb_t.active?)
		@cb_script=cb_t		   
		bbox.add bhbox_script
	elsif alert_type == "pager"
		cb_t.set_sensitive(false)
	else
		bbox.add cb_t
	end

  inherit_conf_cb.signal_connect("clicked") {|s|
	@entry_level.set_sensitive(!inherit_conf_cb.active?)
  	for alert_check_button in chbutton
		alert_check_button.set_sensitive(!inherit_conf_cb.active?)
		if alert_check_button.label.downcase.gsub(/\s.*/,"") == "mail"
 			@cb_mail.set_sensitive(Contact::contact_nb_entry()>0)
			@entry_mail_button.set_sensitive(!inherit_conf_cb.active? && alert_check_button.active? && $config.mail_server && (Contact::contact_nb_entry()>0))
		end
		if alert_check_button.label.downcase.gsub(/\s.*/,"") == "im"
			@cb_im.set_sensitive(Contact::contact_nb_entry()>0)
			@entry_im_button.set_sensitive(!inherit_conf_cb.active? && alert_check_button.active? && $config.im_daemon && (Contact::contact_nb_entry()>0))
		end
		if alert_check_button.label.downcase.gsub(/\s.*/,"") == "sms"
		 	@cb_sms.set_sensitive(Contact::contact_nb_entry()>0)
			@entry_sms_button.set_sensitive(!inherit_conf_cb.active? && alert_check_button.active? && ($config.sms_device != "") && (Contact::contact_nb_entry()>0)) 
		end
		if alert_check_button.label.downcase == "beep"
			bhbox_sound_file.set_sensitive(!inherit_conf_cb.active? && alert_check_button.active?)
		end
		if alert_check_button.label.downcase.gsub(/\s.*/,"") == "script"
			@entry_script.set_sensitive(!inherit_conf_cb.active? && alert_check_button.active?)
		end
	end
	#toggle inherit value
	node.inherit_from_global=inherit_conf_cb.active?
  }


    cb_t.signal_connect("clicked") {|s|
	lbl=s.label.downcase.gsub(/\s.*/,"")
	pos=$talert_type.index(lbl)
      node.alert_type_by_level[@entry_level.active_text][pos] = s.active?
		if lbl == "mail"
			@entry_mail_button.set_sensitive(s.active? && (Contact::contact_nb_entry()>0))
		elsif lbl == "beep"
			@entry_soundfile.set_sensitive(s.active?)
			label_soundfile.set_sensitive(s.active?)
		elsif lbl == "sms"
			@entry_sms_button.set_sensitive(s.active? && (Contact::contact_nb_entry()>0))
		elsif lbl == "im"
			@entry_im_button.set_sensitive(s.active? && (Contact::contact_nb_entry()>0))
		elsif lbl == "script"
			@entry_script.set_sensitive(s.active?)
		end
    }

  end

	@entry_soundfile.signal_connect("changed") {
		if @entry_soundfile.active_text == ConfigGlobal::DEFAULT_SOUND_FILE
			node.sound_file_path_by_level[@entry_level.active_text] = nil
		else
			node.sound_file_path_by_level[@entry_level.active_text] = @entry_soundfile.active_text
		end
	}
	
  @entry_level.signal_connect("changed") {
	if (@entry_level.active_text != "")
		#store old level info
		node.mail_by_level[@old_sev_level]=@entry_mail
		if @entry_soundfile.active_text == ConfigGlobal::DEFAULT_SOUND_FILE
			node.sound_file_path_by_level[@old_sev_level] = nil
		else
			node.sound_file_path_by_level[@old_sev_level] = @entry_soundfile.active_text
		end
		node.script_name_by_level[@old_sev_level] = @entry_script.text
		node.sms_num_by_level[@old_sev_level] = @entry_sms
		node.im_dest_by_level[@old_sev_level] = @entry_im
	  #reload checkbox depending on level selected
	  i=0
	  current_level=@entry_level.active_text
	  for cb in chbutton
		  cb.set_active(node.alert_type_by_level[current_level][i])
		  i+=1
	  end
	  #reload specific entry
		  if node.mail_by_level[current_level]
			@entry_mail=node.mail_by_level[current_level]
		  else
			@entry_mail.clear
		  end
		  if $config.mail_server && (Contact::contact_nb_entry()>0)
		  	@cb_mail.set_sensitive true
		  else
		  	@cb_mail.set_sensitive false
		  end
		  if $config.mail_server && @cb_mail.active? && (Contact::contact_nb_entry()>0)
		  	@entry_mail_button.set_sensitive true
		  else
		  	@entry_mail_button.set_sensitive false
		  end

		  if node.sound_file_path_by_level[current_level] != nil
			  iter=files.index(node.sound_file_path_by_level[current_level])
			  if iter == nil
				  @entry_soundfile.set_active(files.size()-1)
			  else
				  @entry_soundfile.set_active(iter)
			  end
		  else
			  @entry_soundfile.set_active(files.size()-1)
		  end
		  
		  if node.script_name_by_level[current_level] && (node.script_name_by_level[current_level] != "")
		  	@entry_script.set_text node.script_name_by_level[current_level]
		  else
		  	@entry_script.set_text("")
			@cb_script.active=false		  	
		  end

		  if node.sms_num_by_level[current_level]
		  	@entry_sms=node.sms_num_by_level[current_level]
		  else
		  	@entry_sms.clear
		  end
		  if ($config.sms_device != "") && (Contact::contact_nb_entry()>0)
		  	@cb_sms.set_sensitive(true)
		  else
		  	@cb_sms.set_sensitive(false)
		  end		  
		  if ($config.sms_device != "") && @cb_sms.active? && (Contact::contact_nb_entry()>0)
		  	@entry_sms_button.set_sensitive(true)
		  else
		  	@entry_sms_button.set_sensitive(false)
		  end		  
		  if node.im_dest_by_level[current_level] != nil
		  	@entry_im=node.im_dest_by_level[current_level]
		  else
		  	@entry_im.clear
		  end
		  if $config.im_daemon && (Contact::contact_nb_entry()>0)
		  	@cb_im.set_sensitive(true)
		  else
		  	@cb_im.set_sensitive(false)
		  end
		  if $config.im_daemon && @cb_im.active? && (Contact::contact_nb_entry()>0)
		  	@entry_im_button.set_sensitive(true)
		  else
		  	@entry_im_button.set_sensitive(false)
		  end		  

	@old_sev_level=current_level
	end
  }
	hbox = Gtk::HBox.new(FALSE, 1)
	hbox.add Gtk::Image.new(Gtk::Stock::FIND_AND_REPLACE, Gtk::IconSize::MENU)
	hbox.add Gtk::Label::new("Alert")
	hbox.show_all
  notebook.append_page frame, hbox


###### GENERAL TAB #########

  frame = Gtk::Frame::new
  frame.border_width=10
  frame.set_size_request(300, 390)
  frame.show
  vbox = Gtk::VButtonBox.new
  vbox.set_layout_style(Gtk::ButtonBox::SPREAD)
  vbox.show
  frame.add vbox

#resize node icon
  hbox = Gtk::HButtonBox.new
  hbox.set_layout_style(Gtk::ButtonBox::SPREAD)
  hbox.show
  vbox.add hbox

  button_ps = Gtk::CheckButton.new "Resize node icon"
  button_ps.show
  hbox.add button_ps

  entry_pixmap_size = Gtk::Entry.new
  entry_pixmap_size.show
  entry_pixmap_size.set_size_request 3,-1
  if node.node_size == nil
    entry_pixmap_size.set_text($config.pixmap_size.to_s())
  else
    entry_pixmap_size.set_text(node.node_size.to_s())
  end

  entry_pixmap_size.set_sensitive node.node_size != nil
  button_ps.active=node.node_size != nil

  button_ps.signal_connect("toggled") {
    if !button_ps.active?
      entry_pixmap_size.set_sensitive false
      entry_pixmap_size.set_text($config.pixmap_size.to_s())
    else
      entry_pixmap_size.set_sensitive true
		if node.node_size == nil
	      entry_pixmap_size.set_text($config.pixmap_size.to_s())
		else
			entry_pixmap_size.set_text(node.node_size.to_s())
		end
    end
  }
  hbox.add entry_pixmap_size

#end of resize node icon

#bg color
  hbb=Gtk::HButtonBox.new
  hbb.set_layout_style(Gtk::ButtonBox::SPREAD)
  hbb.show

  colorchk = Gtk::CheckButton.new("Color")
  colorchk.show
  vbox.add colorchk

  color_button = Gtk::ColorButton.new
  color_button.set_use_alpha(false)

  gdk_color=nil
  if (node.map_bg_data == nil) || (node.map_bg_type != "color")
		gdk_color=Gdk::Color.new($config.rgb[0].to_f, $config.rgb[1].to_f, $config.rgb[2].to_f)
  else
		gdk_color=Gdk::Color.new(node.map_bg_data[0].to_f, node.map_bg_data[1].to_f, node.map_bg_data[2].to_f)
  end
  color_button.set_color(gdk_color)
  hbb.add color_button
  color_button.show
  vbox.add hbb

#end of bg color

#bg image

  imagechk = Gtk::CheckButton.new("Image")
  imagechk.show
  vbox.add imagechk

  hbb2=Gtk::HButtonBox.new
  hbb2.set_layout_style(Gtk::ButtonBox::SPREAD)
  hbb2.show

  #remove dir name and file format from file bg path
  file_bg = nil
  if node.map_bg_data and (node.map_bg_type == "image")
     file_bg = node.map_bg_data[1+ String.new("bg").size, node.map_bg_data.size - 2 - String.new("bg").size - String.new("jpg").size]
  else
     if $config.image_path
        file_bg = $config.image_path[1+ String.new("bg").size, $config.image_path.size - 2 - String.new("bg").size - String.new("jpg").size]
     end
  end

  entry_image = Gtk::ImageComboList.new("bg", file_bg, "jpg")
  entry_image.show
  hbb2.add entry_image
  vbox.add hbb2

  if node.map_bg_type != nil
	  if node.map_bg_type == "image"
		colorchk.set_active false
		color_button.set_sensitive false
		imagechk.set_active true
	  	entry_image.set_sensitive true
	  else
		colorchk.set_active true
		color_button.set_sensitive true
		imagechk.set_active false
		entry_image.set_sensitive false
	  end
  else
		colorchk.set_active false
		color_button.set_sensitive false
		imagechk.set_active false
		entry_image.set_sensitive false
  end

   colorchk.signal_connect("toggled") {
		if colorchk.active?
			color_button.set_sensitive(true)
			imagechk.set_active false
			entry_image.set_sensitive false
		else
		  	color_button.set_sensitive(false)
		end

	}
   imagechk.signal_connect("clicked") {
		if imagechk.active?
		  	entry_image.set_sensitive(true)
			colorchk.set_active false
			color_button.set_sensitive false
		else
		  	entry_image.set_sensitive(false)
		end
  }

	hbox = Gtk::HBox.new(FALSE, 1)
	hbox.add Gtk::Image.new(Gtk::Stock::SELECT_COLOR, Gtk::IconSize::MENU)
	hbox.add Gtk::Label::new("Display")
	hbox.show_all
  notebook.append_page frame, hbox

###############

   ok_button = Gtk::Button.new(Gtk::Stock::SAVE)
   ok_button.signal_connect("clicked") { 

    #general
	if entry_x.text.to_i >= 0 && entry_x.text.to_i <= $win.window.geometry[2]
		node.x = entry_x.text.to_i
	end
	if entry_y.text.to_i >= 0 && entry_y.text.to_i <= $win.window.geometry[3]
		node.y = entry_y.text.to_i
	end

	need_reload_icon=0
	if entry_os.name != node.os || entry_type.name != node.type
	  need_reload_icon=1
	end
  
  nodeid=db_get_node_id(node.ip, NETWORKNODE)
  node.netmask = entry_mask.text.to_i
  db_set_mask(nodeid, node.netmask)
  
  if (entry_name.text=="") || (entry_name.text.match('\s+'))
	node.name=Node::NONAME_PROPERTY
  else
  	node.name = entry_name.text
  end
  if (entry_dname.text=="") || (entry_dname.text.match('\s+'))
	node.dns_domain=Node::NONAME_PROPERTY
  else
  	node.dns_domain = entry_dname.text
  end
  if (entry_netbiosname.text=="") || (entry_netbiosname.text.match('\s+'))
	node.netbios_domain=Node::NONAME_PROPERTY
  else
  	node.netbios_domain = entry_netbiosname.text
  end
  if (entry_desc.text=="") || (entry_desc.text.match('\s+'))
	node.description=Node::NODESCR_PROPERTY
  else
  	node.description = entry_desc.text
  end
  db_set_description(nodeid, node.description)
  
  node.snmp_version = combo_snmp_version.active_text
  node.snmp_port = port_spinner.value_as_int
  node.snmp_timeout = timeout_spinner.value_as_int
  node.snmp_retry = retry_spinner.value_as_int
  db_set_snmp_parameter(nodeid, node.snmp_version, node.snmp_port, node.snmp_timeout, node.snmp_retry)

  node.os = entry_os.name
  if entry_type.filename != nil
    node.type = entry_type.name
  end
  node.change_label()
  if need_reload_icon == 1
    node.reload()
  end

  node.node_size=entry_pixmap_size.text.to_i
  db_set_node_size(nodeid, node.node_size)

  #store account only in db as the lived value is already stored in @acccount hash
  node.clear_db_accounts()
  account_table = Array.new()
  @account_view.model.each {|model, path, iter|
      	idname 		= iter[0]
      	login		= iter[1]
	password	= iter[2]
	account_table.push([idname, login, password])
  }
  if account_table.length > 0
    node.add_db_account(account_table)
  end
  
  #store alert override in db if needed

  #store current level entries
  node.mail_by_level[@entry_level.active_text]=@entry_mail
  node.sms_num_by_level[@entry_level.active_text]=@entry_sms
  node.im_dest_by_level[@entry_level.active_text]=@entry_im
  node.script_name_by_level[@entry_level.active_text]=@entry_script.text
  #sound file entry was already saved in the on changed event

  db_del_alert_override(node.ip)
  if !node.inherit_from_global
	#this node has its own alert conf
	db_set_alert_override(node, NETWORKNODE)
  end

  if colorchk.active?
	node.map_bg_type="color"
	node.map_bg_data=color_button.color().to_a()
	db_set_background(nodeid, node.map_bg_type, node.map_bg_data.join(" "))
  else
  	if imagechk.active?
		node.map_bg_type="image"
		node.map_bg_data=entry_image.filename
	else
		node.map_bg_type=nil
		node.map_bg_data=nil
	end
	db_set_background(nodeid, node.map_bg_type, node.map_bg_data)
  end

   Thread.kill(refresh_node_sev_display) unless !refresh_node_sev_display
   Gtk.thread_flush
	window.destroy
	}

	cancel_button = Gtk::Button.new(Gtk::Stock::CANCEL)
	cancel_button.signal_connect("clicked") {
		#we rollback here the account from the db to the @account hash
		node.init_account_from_db()
   		Thread.kill(refresh_node_sev_display) unless !refresh_node_sev_display
		Gtk.thread_flush
		window.destroy
	}
	
	hbox=Gtk::HBox.new(FALSE, 10)
	hbox.border_width=10
	hbox.show
	hbox.pack_start(ok_button, TRUE, TRUE, 0)
	ok_button.set_flags(Gtk::Widget::CAN_DEFAULT);
	hbox.pack_start(cancel_button, TRUE, TRUE, 0)
	cancel_button.set_flags(Gtk::Widget::CAN_DEFAULT);
	separator = Gtk::HSeparator::new()
	vboxb.pack_start(separator, FALSE, TRUE, 0)
	separator.show
	vboxb.pack_start(hbox, FALSE, TRUE, 0)

	ok_button.show
	cancel_button.show

	window.show
    
  end
end
