require "#{GNMSLIB}"+'/gui/link_view'

class Link
	attr_accessor :node1, :node2

   def initialize(n1, n2)
	#true for up, false for down
	@state=true
	@name=nil
	@speed=nil
	@node1=n1
	@node2=n2
	$links.push(self)
	@node1.add_link(self)
	@node2.add_link(self)
	@view=LinkView.new(n1.map, self, [@node1.status, @node2.status].max)
   end

	def point?(node)
		if (node==@node1) || (node==@node2)
			return true
		end
		return false	
	end

	def show()
		@view.show()
	end

	def hide()
		@view.hide()
	end

	def display()
		@view.display()
	end

	def remove_link()
		@view.remove_link()
	end
	
	def update_status()
	  @view.update_status([@node1.status, @node2.status].max)
	end
end #class
