require "#{GNMSLIB}"+'/monitor/server/snmp/snmptrap_server'
require "#{GNMSLIB}"+'/monitor/server/msg_buffer'
require "#{GNMSLIB}"+'/monitor/server/snmp/snmptrap_analyzer'

class SnmpTrapCapture
  def initialize()
	 if $config.snmptrap_mon
		buff=MsgBuffer.new(1)
		begin
			@input = SnmpTrapServer.new(buff)
			@output = SnmpAnalyzer.new(buff)
		rescue Errno::EADDRINUSE => msg
		rescue Errno::EACCES => msg
		   $log.error "SNMP Trap Server: not started"
		end
	 end
	end

	def stop()
		if @input != nil
			@input.close_socket()
		end
		$log.debug("end of SyslogServer thread")
		#output thread will be done auto
	end
end
