=begin header

Property of a node

David Maciejak
20/01/2003

=end

require "#{GNMSLIB}"+'/node_listener'
require "#{GNMSLIB}"+'/monitor/client/snmp/snmp'
require "#{GNMSLIB}"+'/node'
require "#{GNMSLIB}"+'/gui/node_host_property'
require "#{GNMSLIB}"+'/gui/node_network_property'
require "#{GNMSLIB}"+'/gui/color_macro'

if $defined_lib_gruff
  begin
	  require 'gruff'
	  require "#{GNMSLIB}"+'/gui/charts/gruff'
  rescue LoadError
	  $log.error("gruff ruby or rmagick library to display charts is missing, you will not be able to see them")
	  $defined_lib_gruff=false
  rescue RuntimeError => $msg
	$log.error($msg)
 	$defined_lib_gruff=false
  end
end

def node_property(node)
  if node.status == UNMANAGED
    return
  end
  if node.class == Host
	  NodeHostProperty.new(node)
  else
	  NodeNetworkProperty.new(node)
  end
end
